&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : ed4w-se.w
    Purpose     : Ed4W Appbuilder Section Editor extensions

    Syntax      : This procedure is run from _adeevnt.p

    Description :

    Author      : Tim Townsend
    Created     : 8/27/01
    Notes       : 
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters */
def input parameter pProc   as handle no-undo.
def input parameter pWindow as handle no-undo.

/* Variables */
def var vEd4WPath               as char           no-undo.
def var vEditor                 as widget-handle  no-undo.
def var vDummyWindow            as widget-handle  no-undo.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


on close of this-procedure
  delete object this-procedure.

/* ***************************  Main Block  *************************** */

/* create a dummy window so we know when to close */
create window vDummyWindow
  assign hidden = true
         parent = pWindow
  triggers:
    on parent-window-close do:
      apply "close":u to this-procedure.
    end.
  end triggers.


run Initialize.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-EditInEd4W) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE EditInEd4W Procedure 
PROCEDURE EditInEd4W :
/*------------------------------------------------------------------------------
  Purpose:     Edit the section in Ed4W
  Parameters:  
  Notes:
------------------------------------------------------------------------------*/

def var iTempFile   as char no-undo.
def var iInstance   as int no-undo.
def var iAns        as log init true no-undo.
def var iLine       as int no-undo.
def var iDebugAlert as log no-undo.

assign iTempFile           = session:temp-directory + "UIBSection.i"
       iDebugAlert         = session:debug-alert
       session:debug-alert = false.
if valid-handle(vEditor) and not vEditor:read-only and
   vEd4WPath <> ? then
do:
  iLine = vEditor:cursor-line.
  vEditor:save-file(iTempFile).

  os-command no-wait
    value("start ed32.exe " + iTempFile + " -1 -l " + string(iLine)).
  message "Edit the section in Ed4W, then save it and close it." skip
          "Press OK when finished."
          view-as alert-box info buttons ok-cancel
          title "Edit in Ed4W"
          update iAns.
  if iAns then do:
    vEditor:read-file(iTempFile).
    vEditor:modified = true.
    apply "entry" to vEditor.
    process events.
    assign vEditor:cursor-line = iLine no-error.
  end.

  /* move to top */
  pWindow:move-to-top() no-error.

  os-delete value(iTempFile).
  session:debug-alert = iDebugAlert.
end.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-Initialize) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Initialize Procedure 
PROCEDURE Initialize :
/*------------------------------------------------------------------------------
  Purpose:     Initializations
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def var iFrame     as widget-handle no-undo.
def var iFieldGrp  as widget-handle no-undo.
def var iWidget    as widget-handle no-undo.
def var iMenuBar   as widget-handle no-undo.
def var iMenu      as widget-handle no-undo.
def var iEditInEd  as widget-handle no-undo.
def var iProc      as handle        no-undo.
def var iThisProc  as handle        no-undo.
def var iMainProc  as handle        no-undo.

  assign 
    vEd4WPath = search("c:\program files\SAIG\ED4W\ED32.exe")
    vEd4WPath = "ED32.exe"
    vEditor   = ? 
    iFrame    = pWindow:first-child
    this-procedure:private-data = string(pProc).
  
  do while iFrame:type <> "frame":
    iFrame = iFrame:next-sibling.
  end.
  
  /* Find the editor widget */
  assign
    iFieldGrp = iFrame:first-child  
    iWidget   = iFieldGrp:first-tab-item
    no-error.

  do while iWidget <> ? and vEditor = ?:
    if iWidget:type = "Editor" then
      vEditor = iWidget.
    iWidget = iWidget:next-tab-item.
  end.

  /* Find the Edit menu */
  assign 
    iMenuBar = pWindow:menu-bar
    iMenu    = iMenuBar:first-child.
  do while valid-handle(iMenu) and replace(iMenu:label,"&","") <> "Edit":
    iMenu = iMenu:next-sibling.
  end.  /* do while */

  if valid-handle(iMenu) then do:
    create menu-item iEditInEd
      assign label       = "Edit in Ed4W"
             accelerator = "Ctrl-E"
             parent      = iMenu
      triggers:
        on choose persistent
          run EditInEd4W in this-procedure.
      end triggers.
  end.
  
  /* Look for orphans, in case some instances didn't get closed properly */
  assign iProc = session:first-procedure.
  do while valid-handle(iProc):
    assign
      iThisProc = iProc
      iProc     = iProc:next-sibling.
    if iThisProc:file-name =  this-procedure:file-name and
       iThisProc:handle    <> this-procedure:handle then do:
      assign
        iMainProc = ?
        iMainProc = widget-handle(iThisProc:private-data) no-error.
      if not valid-handle(iMainProc) or
         iMainProc = ? or
         iMainProc:type <> "procedure":u or
         iMainProc:file-name <> pProc:file-name then do:
        apply "close":u to iThisProc.
      end.
    end.  /* if */
      
  end.  /* do while */
  
  return.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

